// src/stores/common.ts
import { defineStore } from 'pinia'
import { useDefaultSetProp } from '../hooks/useDefaultSetProp'

export interface TokenDto {
  AccessToken: string
  RefreshToken: string
}

export const useTokenStore = defineStore(
  'token',
  () => {
    const { model: token, setModel: setToken } = useDefaultSetProp<Partial<TokenDto | undefined>>({})
    return { token, setToken }
  },
  {
    persist: true
  }
)
