import { ref } from 'vue'
import type { Ref } from 'vue'

const useDefaultSetProp = <P extends unknown>(p: P, afterSet?: (p: P) => void) => {
  const model = ref<P>(p) as Ref<P>

  function setModel(newModel: P) {
    model.value = newModel
    if (afterSet) {
      afterSet(newModel)
    }
  }

  return { model, setModel }
}

export { useDefaultSetProp }
