import { execa } from 'execa'
import { resolve } from 'path'
import inquirer from 'inquirer'

const CWD = process.cwd()
let Auth = resolve(CWD, './workspace/AntDesignOfVue_Auth')
let BadEvent = resolve(CWD, './workspace/AntDesignOfVue_BadEvent')
let Board = resolve(CWD, './workspace/AntDesignOfVue_Board')
let Hr = resolve(CWD, './workspace/AntDesignOfVue_Hr')
let InitProjectTemplate = resolve(CWD, './workspace/AntDesignOfVue_InitProjectTemplate')
let IntelligentOM = resolve(CWD, './workspace/AntDesignOfVue_IntelligentOM')
let QualityInspection = resolve(CWD, './workspace/AntDesignOfVue_QualityInspection')
// let ScheduleShift = resolve(CWD, './workspace/AntDesignOfVue_ScheduleShift')
let Supply = resolve(CWD, './workspace/AntDesignOfVue_Supply')
let Writ = resolve(CWD, './workspace/AntDesignOfVue_Writ')

const run = (bin, args, opts = {}) => execa(bin, args, { stdio: 'inherit', ...opts })

async function create() {
  const { fruit } = await inquirer.prompt([
    {
      type: 'list',
      message: '请选择您要运行的子项目:',
      name: 'fruit',
      choices: [
        {
          key: '0',
          name: '物资',
          value: 'Supply'
        },
        {
          key: '1',
          name: '不良事件',
          value: 'BadEvent'
        },
        {
          key: '2',
          name: '智能运维',
          value: 'IntelligentOM'
        },
        {
          key: '3',
          name: '综合管理平台',
          value: 'Auth'
        },
        {
          key: '4',
          name: '护理文书',
          value: 'Writ'
        },
        {
          key: '5',
          name: '护理质量',
          value: 'QualityInspection'
        },
        {
          key: '6',
          name: 'HR',
          value: 'HR'
        },
        {
          key: '7',
          name: '护理看板后台',
          value: 'Board'
        },
        {
          key: '8',
          name: '项目模板',
          value: 'InitProjectTemplate'
        }
        // {
        //   key: '7',
        //   name: '排班系统',
        //   value: 'ScheduleShift'
        // },
      ]
    }
  ])

  switch (fruit) {
    case 'Supply':
      run('yarn', ['build'], { cwd: Supply })
      break
    case 'BadEvent':
      run('yarn', ['build'], { cwd: BadEvent })
      break
    case 'IntelligentOM':
      run('yarn', ['build'], { cwd: IntelligentOM })
      break
    case 'Auth':
      run('yarn', ['build'], { cwd: Auth })
      break
    case 'Writ':
      run('yarn', ['build'], { cwd: Writ })
      break
    case 'QualityInspection':
      run('yarn', ['build'], { cwd: QualityInspection })
      break
    case 'HR':
      run('yarn', ['build'], { cwd: Hr })
      break
    case 'ScheduleShift':
      run('yarn', ['build'], { cwd: ScheduleShift })
      break
    case 'Board':
      run('yarn', ['build'], { cwd: Board })
      break
    case 'InitProjectTemplate':
      run('yarn', ['build'], { cwd: InitProjectTemplate })
      break
  }
}

create()
